--
--
--
waterSim  = sprite:new()
--This class is the base class for all graphical objects.
--
--
waterSim.graphic = players.defaultBullet
waterSim.topOfWater = {}
waterSim.topOfWaterSpeed  = {}
waterSim.x = 0
waterSim.y = 0
waterSim.width = 0
waterSim.height = 0
waterSim.forMe = 0;
waterSim.inc = 0



function waterSim:update(dt)
	self.inc = self.inc + 1
	local t = nil
	t = table.shallow_copy(self.topOfWater)
	for nam, p in pairs(t) do
		if nam % 2 == 0 then 
		
			if nam ~= 2 and nam ~= self.forMe then
				t[nam] = t[nam] + (self.topOfWater[nam-2]/10)
				t[nam] = t[nam] + (self.topOfWater[nam+2]/10)
			elseif nam == 2 then
				t[nam] = t[nam] + (self.topOfWater[nam+2]/10)
			elseif self.forMe == nam then
				t[nam] = t[nam] + (self.topOfWater[nam-2]/10)
			end
		end
	end

	self.topOfWater = table.shallow_copy(t)

	
	for nam, p in pairs(t) do
		if nam % 2 == 0 then 
			self.topOfWaterSpeed[nam] = self.topOfWaterSpeed[nam] + ((0 - self.topOfWater[nam]) / 20)
			self.topOfWater[nam] = self.topOfWater[nam] + (self.topOfWaterSpeed[nam])
			self.topOfWaterSpeed[nam] = self.topOfWaterSpeed[nam]*.8
		end
	end
	
	if self.inc % 10 == 0 then
		for nam, p in pairs(t) do
			if nam % 2 == 0 then 
				if math.random()<.3 then
					self.topOfWaterSpeed[nam] = self.topOfWaterSpeed[nam]  + (.5-(math.random()*1))
				end				
			end
		end
	end
	

if input:pressed('down')then 
	
	
	end
end

function waterSim:hitTest(lx,ly)
		
	if lx>self.x and lx<self.x+self.width then
		local startPos = math.floor((lx - self.x )/7) * 2
		if startPos % 2 ~= 0 then
			startPos = startPos + 1
		end
		if self.topOfWater[startPos] ~= nil then
			if ly<self.y+self.width and ly>self.y+self.topOfWater[startPos] then
					return true
			end
		end
	end
	return false
end
function waterSim:disturb(lx, ls)
	
	if lx - self.x > 0 and lx-self.x < self.width then
		
		local startPos = math.floor((lx - self.x )/7) * 2

		if startPos % 2 ~= 0 then
			startPos = startPos + 1
		end
		ls = ls *.5
		self.topOfWaterSpeed[startPos] = ls
		for i = 0, 11, 1 do
			if self.topOfWaterSpeed[startPos-(i*2)] ~= nil then 
				self.topOfWaterSpeed[startPos-(i*2)] = ls*(.99-((i*i)/(11*11)))
			end
			if self.topOfWaterSpeed[startPos+(i*2)] ~= nil then 
				self.topOfWaterSpeed[startPos+(i*2)] = ls*(.99-((i*i)/(11*11)))
			end
		end
		ls = ls *-.3
		
		for i = 0,5, 1 do
			if self.topOfWaterSpeed[startPos-(i*2)+32] ~= nil then 
				self.topOfWaterSpeed[startPos-(i*2)+32] = ls*(.99-((i*i)/(5*5)))
			end
			if self.topOfWaterSpeed[startPos+(i*2)+32] ~= nil then 
				self.topOfWaterSpeed[startPos+(i*2)+32] = ls*(.99-((i*i)/(5*5)))
			end
		end
		
		for i = 0,5, 1 do
			if self.topOfWaterSpeed[startPos-(i*2)-32] ~= nil then 
				self.topOfWaterSpeed[startPos-(i*2)-32] = ls*(.99-((i*i)/(5*5)))
			end
			if self.topOfWaterSpeed[startPos+(i*2)-32] ~= nil then 
				self.topOfWaterSpeed[startPos+(i*2)-32] = ls*(.99-((i*i)/(5*5)))
			end
		end
		local pp = 0





		while pp<20 do
			if ls<0 then
				addParticle('waterDrop',
								lx-10+math.random(20),
								self.y+self.topOfWater[startPos]+20,
								6-(math.random()*12),
								-2-(math.random()*3) + (ls/10),
								1,
								1,
								0,
								function(part) 
									if(not part.init) then
										part.scaleX = .8+math.random()
										part.init = true
										part.drop = math.random()
										part.lifeTime = 0
									end 
									part.lifeTime =  part.lifeTime+1
									part.xSpeed = part.xSpeed * .98 
									part.ySpeed = part.ySpeed +  .2
									
									if cWithLevel(part.x,part.y) then
										part.remove = true
									end 
									if part.lifeTime >20 then
										for nam, obj in pairs(curMap.layers.water.objects) do								
											if spriteList["water"..obj.x]:hitTest(part.x,part.y) then
												
												part.remove = true
												break;
											end									
										end   
									end
									
								end)
			else
					addParticle('waterDrop',
								lx-10+(math.random()*20),
								self.y+self.topOfWater[startPos],
								6-(math.random()*12),
								-4-(math.random()*3) + (ls/10),
								1,
								1,
								0,
								 function(part) 
									if(not part.init) then
										part.scaleX = .8+math.random()
										part.init = true
										part.drop = math.random()
										part.lifeTime = 0
									end 
									part.lifeTime =  part.lifeTime+1
									part.xSpeed = part.xSpeed * .98 
									part.ySpeed = part.ySpeed +  .2
									
									if cWithLevel(part.x,part.y) then
										part.remove = true
									end 
									if part.lifeTime >20 then
										for nam, obj in pairs(curMap.layers.water.objects) do								
											if spriteList["water"..obj.x]:hitTest(part.x,part.y) then
												
												part.remove = true
												break;
											end									
										end   
									end
									
								end)
			end
			
			pp = pp + 1
		end
	end
	
	
end
function waterSim:draw()
	local t = table.shallow_copy(self.topOfWater)

	table.insert(t,self.width)
	table.insert(t,self.height)
	table.insert(t,0)
	table.insert(t,self.height)
	table.insert(t,0)
	table.insert(t,self.topOfWater[2])
	

	
	love.graphics.push()
 --draw something here

	love.graphics.setLineWidth(2)
	love.graphics.translate(self.x, self.y )

	
	triangles = love.math.triangulate( t )

	love.graphics.setColor( 0, 128, 255, 100 )

	love.graphics.line(t)
	love.graphics.setLineWidth(3)
	love.graphics.line(t)
	love.graphics.setColor( 0, 128, 200, 140)
	for nam, p in pairs(triangles) do
		love.graphics.polygon('fill',p  )
	end
	--love.graphics.line(t)
	love.graphics.setColor( 255, 255, 255, 255 )
	love.graphics.pop()
end

function waterSim:inits(lx,ly,lwidth,lheight)
	local i = 0
	self.x = lx
	self.y = ly
	self.width = lwidth
	self.height = lheight
	self.topOfWater = {}
	self.topOfWaterSpeed = {}
	while i<self.width do
		
		table.insert(self.topOfWater,i)
		
		table.insert(self.topOfWater,0)
		i = i+7
		self.forMe = self.forMe + 2 
		
		table.insert(self.topOfWaterSpeed,0)
		table.insert(self.topOfWaterSpeed,0)
	
		
	end
	

	table.insert(self.topOfWater,self.width)
	table.insert(self.topOfWater,0)
	
	table.insert(self.topOfWaterSpeed,0)
	table.insert(self.topOfWaterSpeed,0)
	self.forMe = self.forMe + 2 
		print(self.topOfWater[1])
end