smokeShader = love.graphics.newShader[[

vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
		{

		number pW = 1/love_ScreenSize.x;//pixel width 
		number pH = 1/love_ScreenSize.y;//pixel height

		vec4 pixel = Texel(texture, texture_coords );//This is the current pixel 

		vec2 coords = vec2(texture_coords.x-pW,texture_coords.y-pH);
		vec4 Lpixel = Texel(texture, coords );//Pixel on the left

		coords = vec2(texture_coords.x+pW,texture_coords.y-pH);
		vec4 Rpixel = Texel(texture, coords );//Pixel on the right

		coords = vec2(texture_coords.x,texture_coords.y-pH);
		vec4 Upixel = Texel(texture, coords );//Pixel on the up

		coords = vec2(texture_coords.x,texture_coords.y+pH+(pH/2));
		vec4 Dpixel = Texel(texture, coords );//Pixel on the down

		pixel.a += 10 * 0.0166667 * (Lpixel.a + Rpixel.a + Dpixel.a * 3 + Upixel.a - 6 * pixel.a);

		pixel.rgb = vec3(1.0,1.0,1.0);


		return pixel;

		}
		]]
		
		
		
		
simple_blur = love.graphics.newShader[[
    extern vec2 image_size;
    extern number intensity = 1.0;

    vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc) {
        vec2 offset = vec2(1.0)/image_size;
        color = Texel(tex, tc);

        color += Texel(tex, tc + intensity*vec2(-offset.x, offset.y));
        color += Texel(tex, tc + intensity*vec2(0.0, offset.y));
        color += Texel(tex, tc + intensity*vec2(offset.x, offset.y));

        color += Texel(tex, tc + intensity*vec2(-offset.x, 0.0));
        color += Texel(tex, tc + intensity*vec2(0.0, 0.0));
        color += Texel(tex, tc + intensity*vec2(offset.x, 0.0));

        color += Texel(tex, tc + intensity*vec2(-offset.x, -offset.y));
        color += Texel(tex, tc + intensity*vec2(0.0, -offset.y));
        color += Texel(tex, tc + intensity*vec2(offset.x, -offset.y));

        return color/9.0;
    }
]]